//-----------------------------------------------------------------------------
// File: main.cpp
//
// Desc: RADIANCE Picture File Format ̓ǂݍ
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
//-----------------------------------------------------------------------------
#define STRICT
#include <stdio.h>
#include "hdr.h"



namespace HDR{

#define  COLXS		128		// ẘl(w̒l̎ɂRGB̐F̂)
#define MAXGSHIFT	31		// K}e[û߂̍őVtg
static BYTE	*g_mant = NULL, *g_nexp = NULL;
static BYTE	(*g_bval)[256] = NULL;


//-----------------------------------------------------------------------------
// F
//-----------------------------------------------------------------------------
typedef BYTE  COLR[4];		/* RGBE */
#define  RED		0
#define  GRN		1
#define  BLU		2
#define  EXP		3


//-----------------------------------------------------------------------------
// wb_ǂݎ
//-----------------------------------------------------------------------------
typedef struct{
	char	mn[64]; // magic number (#?̌A"RADIANCE"ɂ̂ݑΉ)
	char	fs[64];	// tH[}bg
	double	xp;		// I
	int		x;		// 
	int		y;		// 
	unsigned char or;// tO
	int		sl;		// XLC
	int		ns;		// XLC
}Info;

// XLC̏Ԃ̂߂̃tO
#define  XDECR			1	// ̕ɐLт邩ǂ
#define  YDECR			2	// ̕ɐLт邩ǂ 
#define  YMAJOR			4	// ƍŝǂ炪D悩

#define  MINELEN	8		// ŏ摜𑜓x
#define  MAXELEN	0x7fff	// ő摜𑜓x

// WIȕя
#define  PIXSTANDARD		(YMAJOR|YDECR)
#define  PIXSTDFMT		"-Y %d +X %d\n"




//-----------------------------------------------------------------------------
// Name: s_RemoveCRCF()
// Desc: ]ȉs菜
//-----------------------------------------------------------------------------
void s_RemoveCRCF(char *p)
{
	int len;

	for(len = strlen(p)-1; 0<=len; len--)
	{
		if( p[len]!='\r' && p[len]!='\n' ) break;
		p[len] = '\0';
	}
}



//-----------------------------------------------------------------------------
// Name: s_ValData()
// Desc: f[^̕]
//-----------------------------------------------------------------------------
void s_ValData(Info *r, const char  *s)
{
	if(0 == strncmp(s, "#?", 2))
	{// }WbNio[
		strcat(r->mn, s+2);
		s_RemoveCRCF(r->mn);
	}
	else if(0 == strncmp(s, "FORMAT=", 7))
	{// tH[}bg
		strcat(r->fs, s+7);
		s_RemoveCRCF(r->fs);
	}
}


//-----------------------------------------------------------------------------
// Name: s_GetHeader()
// Desc: wb_̓ǂݍ
//-----------------------------------------------------------------------------
int s_GetHeader(FILE  *fp, Info *cp)
{
	const int MAXLINE = 512;
	char  buf[MAXLINE];

	for ( ; ; ) {
		buf[MAXLINE-2] = '\n';
		if (fgets(buf, MAXLINE, fp) == NULL) return(-1);

		if (buf[0] == '\n')	return(0);
		if (buf[0] == '\r' && buf[1] == '\n') return(0);

		if (buf[MAXLINE-2] != '\n') {
			// oCif[^ɂȂƂɂ́Aɖ߂
			buf[MAXLINE-2] = '\0';
		}
		s_ValData(cp, buf);
	}
}




//-----------------------------------------------------------------------------
// Name: s_Str2Resolu()
// Desc:  s 𑜓x𒊏o
//-----------------------------------------------------------------------------
int s_Str2Resolu( Info *r, const char *s )
{
	const char  *xndx = NULL; // 'X' ̒ln܂ꏊ
	const char  *yndx = NULL; // 'Y' ̒ln܂ꏊ
	const char  *cp;

	if (s == NULL) return(0);

	// X  Y ̎n܂ʒu𒲂ׂ
	for (cp = s; *cp; cp++){
		if (*cp == 'X'){
			xndx = cp;
		}else if (*cp == 'Y'){
			yndx = cp;
		}
	}
	
	// ̕񂪓ĂȂƐ̂ł͂ȂB
	if (xndx == NULL || yndx == NULL) return(0);
	
	// tO̊mF
	r->or = 0;
	if (xndx > yndx) r->or |= YMAJOR;
	if (xndx[-1] == '-') r->or |= XDECR;
	if (yndx[-1] == '-') r->or |= YDECR;

	// l̏
	if ((r->x = atoi(xndx+1)) <= 0) return(0);
	if ((r->y = atoi(yndx+1)) <= 0) return(0);

	return(1);
}




//-----------------------------------------------------------------------------
// Name: s_GetResolution()
// Desc: TCY̓ǂݍ
//-----------------------------------------------------------------------------
int s_GetResolution(FILE  *fp, Info *cp)
{
	const int MAXLINE = 512;
	char  buf[MAXLINE];

	buf[MAXLINE-2] = '\n';
	if (fgets(buf, MAXLINE, fp) == NULL) return(-1);

	s_Str2Resolu(cp, buf);

	return (0);
}




//-----------------------------------------------------------------------------
// Name: s_GetResolu()
// Desc: scanline  length  number𓾂
//-----------------------------------------------------------------------------
int s_GetResolu(Info *p)
{
	if (p->or & YMAJOR) {
		p->sl = p->x;
		p->ns = p->y;
	} else {
		p->sl = p->y;
		p->ns = p->x;
	}

	return(0);
}



//-----------------------------------------------------------------------------
// Name: s_CheckHeader()
// Desc: HDR t@C̓ǂݍ݁iԂlP̎ɁAtH[}bgj
//-----------------------------------------------------------------------------
int s_CheckHeader(FILE  *fin, Info *pInfo)
{
	// f[^̏
	pInfo->mn[0] = '\0';
	pInfo->fs[0] = '\0';
	pInfo->xp = 1.0000000000000;
	pInfo->x = 0;
	pInfo->y = 0;
	pInfo->or = 0;
	pInfo->sl = 0;
	pInfo->ns = 0;

	// wb_̏
	if (s_GetHeader(fin, pInfo) < 0) return(-1);
	
	// wb_`FbN
	if (pInfo->mn[0]=='\0' || strcmp("RADIANCE", pInfo->mn) ) return -1;

	// tH[}bg`FbN
	if (pInfo->fs[0]=='\0' || strcmp("32-bit_rle_rgbe", pInfo->fs) ) return -1;

	// TCY`FbN
	if (s_GetResolution(fin, pInfo) < 0) return(-1);
	if (pInfo->x <= 0 || pInfo->y <= 0) return -1;
	s_GetResolu(pInfo);// 摜̃XLČvZ

	// f[^
	return 1;
}




//-----------------------------------------------------------------------------
// Name: s_OldReadColors()
// Desc: ꂽFǂݍ(Â)
//-----------------------------------------------------------------------------
int s_OldReadColors(COLR *scanline, int len, FILE *fp)
{
	int  rshift;
	register int  i;
	
	rshift = 0;
	
	while (0 < len) {
		scanline[0][RED] = getc(fp);
		scanline[0][GRN] = getc(fp);
		scanline[0][BLU] = getc(fp);
		scanline[0][EXP] = getc(fp);
		// f[^ȂG[ŏI
		if (feof(fp) || ferror(fp)) return(-1);

		if (scanline[0][RED] == 1 &&
			scanline[0][GRN] == 1 &&
			scanline[0][BLU] == 1)
		{
			// R=G=B=1 ̂Ƃ́Awf[^𑱂
			// ̃f[^ɑȂAQ{ɂđ
			for (i = scanline[0][EXP] << rshift; i > 0; i--) {
				scanline[0][0]=scanline[-1][0];
				scanline[0][1]=scanline[-1][1];
				scanline[0][2]=scanline[-1][2];
				scanline[0][3]=scanline[-1][3];
				scanline++;
				len--;
			}
			rshift += 8;
		} else {
			scanline++;
			len--;
			rshift = 0;
		}
	}
	return(0);
}




//-----------------------------------------------------------------------------
// Name: CreateTextureFromHdrFile()
// Desc: ꂽFǂݍ
//-----------------------------------------------------------------------------
int s_ReadColor (COLR *scanline, int len, FILE *fp)
{
	int  i, j;
	int  code, val;

	// ǂݍ݂̃^Cv߂
	// ŐV̂̂Ȃ΁Aŏ̂S̐
	// [ 2 | 2 | 摜TCY̏ʂVrbg|摜TCỶʂWrbg ]
	// ɂȂĂ͂
	if (len < MINELEN || MAXELEN < len ){
		// Â^Cv
		return(s_OldReadColors(scanline, len, fp));
	}

	i = getc(fp);
	if (i == EOF) return(-1);// f[^Ȃ

	if (i != 2) {
		// ŏ͂QłȂ̂͌Â^Cv
		ungetc(i, fp);
		return(s_OldReadColors(scanline, len, fp));
	}
	// ŒS̃f[^Kv
	scanline[0][GRN] = getc(fp);
	scanline[0][BLU] = getc(fp);
	if ((i = getc(fp)) == EOF) return(-1);
	
	// ŏ̃f[^"22"ƂɂȂĂȂA
	// RoCgڂ̃f[^ɂčő吔𒴂Ă邩̃`FbN
	if (scanline[0][GRN] != 2 || scanline[0][BLU] & 128) {
		scanline[0][RED] = 2;
		scanline[0][EXP] = i;
		return(s_OldReadColors(scanline+1, len-1, fp));
	}

	// ̊mF
	if ((scanline[0][BLU]<<8 | i) != len) return(-1);

	// eǂݍ
	for (i = 0; i < 4; i++)
	{
	    for (j = 0; j < len; )
		{
			// f[^rłȂȂH
			if ((code = getc(fp)) == EOF) return(-1);

			if (128 < code) {
				// +l̃OX
				code &= 127;
				val = getc(fp);
				while (code--) scanline[j++][i] = val;
			} else {
				// OXłȂ̂code
				while (code--) scanline[j++][i] = getc(fp);
			}
		}
	}
	
	// I[ɒBĂmF
	return(feof(fp) ? -1 : 0);
}




//-----------------------------------------------------------------------------
// Name: CreateTextureFromHdrFile()
// Desc: Radiance XLCtH[}bgRGBEɕϊ
//-----------------------------------------------------------------------------
int Ra2Skel(FILE *fp, int sl, int nl, LPCTSTR *pErr, LPDIRECT3DTEXTURE9 pTexture)
{
	int ret=0;
	COLR	*scanin;
	register int	x;
	int	y;

	// ̊m
	if ((scanin = (COLR *) malloc(sl*sizeof(COLR))) == NULL)
	{
		static LPCTSTR ErrMsg = "Out of memory.";
		if(pErr) *pErr = ErrMsg;
		return -1;
	}

	// eNX`̃bN
	D3DLOCKED_RECT d3dlr;
	if(FAILED(pTexture->LockRect(0, &d3dlr, NULL, 0)))
	{
		static LPCTSTR ErrMsg = "error to lock texture.";
		if(pErr) *pErr = ErrMsg;
		ret = -1;
		goto err1_end;
	}

	// 摜̕ϊ
    BYTE* pDstRow = (BYTE*)d3dlr.pBits;
	for (y = nl-1; y >= 0; y--) {
		if (s_ReadColor(scanin, sl, fp) < 0)
		{
			static LPCTSTR ErrMsg = "error reading Radiance picture.";
			if(pErr) *pErr = ErrMsg;
			ret = -1;
			goto err2_end;
		}

        BYTE* pDst = pDstRow;
		for (x = 0; x < sl; x++) {
			pDst[0] = scanin[x][BLU];
			pDst[1] = scanin[x][GRN];
			pDst[2] = scanin[x][RED];
			pDst[3] = scanin[x][EXP];
			pDst += 4;
		}
        pDstRow += d3dlr.Pitch;
	}
err2_end:

	pTexture->UnlockRect(0);

err1_end:

	// ̊J
	free((char *)scanin);

	return ret;
}




//-----------------------------------------------------------------------------
// Name: CreateTextureFromHdrFile()
// Desc: HDR t@C̓ǂݍ
//-----------------------------------------------------------------------------
HRESULT CreateTextureFromFile(
		LPDIRECT3DDEVICE9 pDevice,
		LPCTSTR pSrcFile,
		LPCTSTR *pErr,
		LPDIRECT3DTEXTURE9 *pTexture)
{
	HRESULT hr = S_OK;
	Info info;

	FILE *fd;
	
	if( (fd = fopen( pSrcFile,"rb" )) == NULL )
	{// t@C̃I[v̎s
		static LPCTSTR ErrMsg = "Can't open input file.";
		if(pErr) *pErr = ErrMsg;
		hr = -1;
		return -1;
	}

	// wb_[𒲂ׂ
	if (s_CheckHeader(fd, &info) < 0)
	{
		static LPCTSTR ErrMsg = "Bad picture format.";
		if(pErr) *pErr = ErrMsg;
		hr = -1;
		goto err_data;// tH[}bg
	}

	// eNX`mۂ
	if(FAILED(hr=D3DXCreateTexture(pDevice, info.x, info.y
					, 1, 0, D3DFMT_A8R8G8B8
					, D3DPOOL_MANAGED, pTexture)))
	{
		static LPCTSTR ErrMsg = "Failed to create texture.";
		if(pErr) *pErr = ErrMsg;
		goto err_data;// tH[}bg
	}

	// Ro[g
	if(	Ra2Skel(fd, info.sl, info.ns, pErr, *pTexture) < 0)
	{
		hr = -1;
	}

err_data:
	// t@C
	fclose( fd );

	return hr;
}

}// namespace HDR


