// -------------------------------------------------------------
// HDR
// 
// Copyright (c) 2003-2004 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------
#include "paraboloid.fx"


// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;
float4x4 mWV;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture Texture;
sampler Sampler = sampler_state
{
    Texture = <Texture>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// AvP[V璸_VF[_ɓnf[^
// -------------------------------------------------------------
struct VS_INPUT
{
    float4 Pos          : POSITION;
    float3 Normal       : NORMAL0;
    float2 Tex          : TEXCOORD0;
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos          : POSITION;
    float2 Tex          : TEXCOORD0;
};

// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS(VS_INPUT In)
{   
	VS_OUTPUT Out = (VS_OUTPUT)0;			 // o̓f[^
	
	// ʒuW
	Out.Pos = mul( In.Pos, mWVP );
	
	// eNX`W
	Out.Tex = In.Tex;
	

    return Out;
}

// -------------------------------------------------------------
// HDRLDRɕϊsNZVF[_vO
// -------------------------------------------------------------
float4 PS( VS_OUTPUT In ) : COLOR
{   
	float4 ldr = (float4)0;
	
    float4 hdr = tex2D( Sampler, In.Tex );
	
	ldr.rgb = saturate( hdr * pow(2, 256*(hdr.a - 0.5) ));
	
    return ldr;
}


// -------------------------------------------------------------
// }bv_VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS_DUAL( VS_INPUT In )
{   
	VS_OUTPUT Out = (VS_OUTPUT)0;			 // o̓f[^
	
	// ʒuW
	Out.Pos = paraboloid( In.Pos, mWV );
	
	// eNX`W
	Out.Tex = In.Tex;
	
    return Out;
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
    pass P0
    {
        VertexShader = compile vs_1_1 VS_DUAL();
        PixelShader  = compile ps_2_0 PS();
    }
}

