// ------------------------------------------------------------
// Real-time Global Illuminations
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------
#include "paraboloid.fx"

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float4x4 mWVP;
float4x4 mWV;
float4 vEye;

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture SrcTex;
sampler SrcSamp = sampler_state
{
    Texture = <SrcTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture ReductionMap;
sampler ReductionSamp = sampler_state
{
    Texture = <ReductionMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture SHTex;
sampler SHSamp = sampler_state
{
    Texture = <SHTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture ParaboloidFrontTex;
sampler ParaboloidFrontSamp = sampler_state
{
    Texture = <ParaboloidFrontTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
texture ParaboloidBackTex;
sampler ParaboloidBackSamp = sampler_state
{
    Texture = <ParaboloidBackTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};


// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float3 Normal		: TEXCOORD2;
	float2 Sphere		: TEXCOORD3;
};

// ------------------------------------------------------------
// wi`撸_VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS (
      float4 Pos    : POSITION           // f̒_
     ,float4 Normal : NORMAL             // @xNg
     ,float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
	// ʒuW
	Out.Pos = mul( Pos, mWVP );
	
	// eNX`W
    Out.Tex0 = Tex0;
	
    return Out;
}
// ------------------------------------------------------------
// wi`sNZVF[_vO
// ------------------------------------------------------------
float4 PS (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// F
	Out = tex2D( SrcSamp, In.Tex0 );
	
	return Out;
}





// ------------------------------------------------------------
// ϊ_VF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS_Parabploid (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex0   : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
	// ʒuW
	Out.Pos = paraboloid( Pos, mWV );
	
	// eNX`W
    Out.Tex0 = Tex0;
	
    return Out;
}
// ------------------------------------------------------------
// S݃sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Parabploid (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// F
	Out = tex2D( SrcSamp, In.Tex0 );
	
	return Out;
}


// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
VS_OUTPUT VS_ParabploidEnvmap (
      float4 Pos    : POSITION           // f̒_
    , float4 Normal : NORMAL             // @xNg
      )
{
    float3 ray;
    float3 ref;
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
	// ʒuW
	Out.Pos = mul( Pos, mWVP );
	
	// bV̐F
	Out.Color = 0.0f;
	
	// eNX`W
    ray = normalize( Pos - vEye ).xyz;
	ref = reflect( ray, Normal.xyz );		// ˃xNg

	Out.Tex0.x = 0.5 * ( 1 + ref.x/(1+ref.z));
	Out.Tex0.y = 0.5 * ( 1 - ref.y/(1+ref.z));
	Out.Tex1.x = 0.5 * ( 1 - ref.x/(1-ref.z));
	Out.Tex1.y = 0.5 * ( 1 - ref.y/(1-ref.z));
	
	Out.Color.w = ref.z + 0.5f;		// ˃xNg̐̔
	
	// @
	Out.Normal = mul( Normal.xyz, mWV );
	
	// SHWp̃XtBAW
	float3 r = Normal;
	r.z += 1.0f;
	float m = 2 * length(r);
	Out.Sphere.x =   Normal.x / m + 0.5f;
	Out.Sphere.y = - Normal.y / m + 0.5f;
	
    return Out;
}


// ------------------------------------------------------------
// S݃sNZVF[_vO
// ------------------------------------------------------------
float4 PS_ParabploidEnvmap (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// GI
	float4 SH = 2.0 * tex2D( SHSamp, In.Sphere ) - 1.0;
	float4 GI =   SH.a * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.25) ) - 1.0)
				+ SH.r * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.75) ) - 1.0)
				+ SH.g * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.25) ) - 1.0)
				+ SH.b * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.75) ) - 1.0);

	// }bv
	float4 front = tex2D( ParaboloidFrontSamp, In.Tex0 );
	float4 back  = tex2D( ParaboloidBackSamp,  In.Tex1 );
	float4 env;
	
	if( 0.5 < In.Color.w ){
		env = front;
	}else{
		env = back;
	}
	// tl
	float F = 1 - In.Normal.z * In.Normal.z;
	
	// F
	Out = 5.0 * GI			// GI
		+ 0.2f * env * F	// }bv
		+ In.Color;			// ̂ق̐F

	return Out;
}


// ------------------------------------------------------------
// S݃sNZVF[_vO
// ------------------------------------------------------------
float4 PS_ParabploidEnvmapNoEnv (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// GI
	float4 SH = 2.0 * tex2D( SHSamp, In.Sphere ) - 1.0;
	float4 GI =   SH.a * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.25) ) - 1.0)
				+ SH.r * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.75) ) - 1.0)
				+ SH.g * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.25) ) - 1.0)
				+ SH.b * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.75) ) - 1.0);

	// }bv
	float4 front = tex2D( ParaboloidFrontSamp, In.Tex0 );
	float4 back  = tex2D( ParaboloidBackSamp,  In.Tex1 );
	float4 env;
	
	if( 0.5 < In.Color.w ){
		env = front;
	}else{
		env = back;
	}
	// tl
	float F = 1 - In.Normal.z * In.Normal.z;
	
	// F
	Out = 5.0 * GI			// GI
		+ In.Color;			// ̂ق̐F

	return Out;
}


// ------------------------------------------------------------
// S݃sNZVF[_vO
// ------------------------------------------------------------
float4 PS_ParabploidEnvmapNoGI (VS_OUTPUT In) : COLOR
{
	float4 Out;
	
	// GI
	float4 SH = 2.0 * tex2D( SHSamp, In.Sphere ) - 1.0;
	float4 GI =   SH.a * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.25) ) - 1.0)
				+ SH.r * ( 2.0 * tex2D( ReductionSamp, float2(0.25, 0.75) ) - 1.0)
				+ SH.g * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.25) ) - 1.0)
				+ SH.b * ( 2.0 * tex2D( ReductionSamp, float2(0.75, 0.75) ) - 1.0);

	// }bv
	float4 front = tex2D( ParaboloidFrontSamp, In.Tex0 );
	float4 back  = tex2D( ParaboloidBackSamp,  In.Tex1 );
	float4 env;
	
	if( 0.5 < In.Color.w ){
		env = front;
	}else{
		env = back;
	}
	// tl
	float F = 1 - In.Normal.z * In.Normal.z;
	
	// F
	Out = 0.2f * env * F	// }bv
		+ In.Color;			// ̂ق̐F

	return Out;
}


// ------------------------------------------------------------
// ------------------------------------------------------------
// ʒuA@}bv̍쐬
// ------------------------------------------------------------
// ------------------------------------------------------------
struct VS_OUTPUT_MAP
{
    float4 Pos			: POSITION;
	float4 Position		: TEXCOORD0;
	float4 Normal		: TEXCOORD1;
};
struct PS_OUTPUT_MAP
{
    float4 Position		: COLOR0;
    float4 Normal		: COLOR1;
};



// ------------------------------------------------------------
// ------------------------------------------------------------
// US{bNX TvO
// ------------------------------------------------------------
// ------------------------------------------------------------

// ------------------------------------------------------------
// O[oϐ
// ------------------------------------------------------------
float MAP_WIDTH;
float MAP_HEIGHT;

// ------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// ------------------------------------------------------------
struct VS_OUTPUT_REDUCTION
{
    float4 Pos			: POSITION;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
	float2 Tex4			: TEXCOORD4;
	float2 Tex5			: TEXCOORD5;
	float2 Tex6			: TEXCOORD6;
	float2 Tex7			: TEXCOORD7;
};

// ------------------------------------------------------------
// _VF[_vO
// ------------------------------------------------------------
VS_OUTPUT_REDUCTION VS_Reduction (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT_REDUCTION Out = (VS_OUTPUT_REDUCTION)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex0 = Tex + float2(3.0f/MAP_WIDTH, 1.0f/MAP_HEIGHT);
    Out.Tex1 = Tex + float2(3.0f/MAP_WIDTH, 3.0f/MAP_HEIGHT);
    Out.Tex2 = Tex + float2(3.0f/MAP_WIDTH, 5.0f/MAP_HEIGHT);
    Out.Tex3 = Tex + float2(3.0f/MAP_WIDTH, 7.0f/MAP_HEIGHT);
    Out.Tex4 = Tex + float2(1.0f/MAP_WIDTH, 1.0f/MAP_HEIGHT);
    Out.Tex5 = Tex + float2(1.0f/MAP_WIDTH, 3.0f/MAP_HEIGHT);
    Out.Tex6 = Tex + float2(1.0f/MAP_WIDTH, 5.0f/MAP_HEIGHT);
    Out.Tex7 = Tex + float2(1.0f/MAP_WIDTH, 7.0f/MAP_HEIGHT);
    
    return Out;
}

// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Reduction ( VS_OUTPUT_REDUCTION In ) : COLOR0
{
	float4 t0 = tex2D(ReductionSamp, In.Tex0);
	float4 t1 = tex2D(ReductionSamp, In.Tex1);
	float4 t2 = tex2D(ReductionSamp, In.Tex2);
	float4 t3 = tex2D(ReductionSamp, In.Tex3);
	
	float4 t4 = tex2D(ReductionSamp, In.Tex4);
	float4 t5 = tex2D(ReductionSamp, In.Tex5);
	float4 t6 = tex2D(ReductionSamp, In.Tex6);
	float4 t7 = tex2D(ReductionSamp, In.Tex7);
	
	float4 t8 = tex2D(ReductionSamp, In.Tex0 + float2(+4.0f/MAP_WIDTH, 0));
	float4 t9 = tex2D(ReductionSamp, In.Tex1 + float2(+4.0f/MAP_WIDTH, 0));
	float4 ta = tex2D(ReductionSamp, In.Tex2 + float2(+4.0f/MAP_WIDTH, 0));
	float4 tb = tex2D(ReductionSamp, In.Tex3 + float2(+4.0f/MAP_WIDTH, 0));
	
	float4 tc = tex2D(ReductionSamp, In.Tex4 + float2(+4.0f/MAP_WIDTH, 0));
	float4 td = tex2D(ReductionSamp, In.Tex5 + float2(+4.0f/MAP_WIDTH, 0));
	float4 te = tex2D(ReductionSamp, In.Tex6 + float2(+4.0f/MAP_WIDTH, 0));
	float4 tf = tex2D(ReductionSamp, In.Tex7 + float2(+4.0f/MAP_WIDTH, 0));
	
	return ((t0+t1+t2+t3)
		   +(t4+t5+t6+t7)
		   +(t8+t9+ta+tb)
		   +(tc+td+te+tf))/16;
}




// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture WeightTex0;
sampler WeightSamp0 = sampler_state
{
    Texture = <WeightTex0>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
texture WeightTex1;
sampler WeightSamp1 = sampler_state
{
    Texture = <WeightTex1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
texture SrcTex0;
sampler SrcSamp0 = sampler_state
{
    Texture = <SrcTex0>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
texture SrcTex1;
sampler SrcSamp1 = sampler_state
{
    Texture = <SrcTex1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// ------------------------------------------------------------
// SH(0,0)
// ------------------------------------------------------------
float4 PS_00 (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
) : COLOR0
{
	float4 Tex2 = Tex;
	Tex2.x = 1-Tex2.x;
	
	return 0.5 + 0.25 * (
		  (2.0 * tex2D( WeightSamp0, Tex ).a - 1.0) * tex2D( SrcSamp0, Tex ) +
		  (2.0 * tex2D( WeightSamp1, Tex ).a - 1.0) * tex2D( SrcSamp1, Tex2) );
}
// ------------------------------------------------------------
// SH(1,0)
// ------------------------------------------------------------
float4 PS_10 (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
) : COLOR0
{
	float4 Tex2 = Tex;
	Tex2.x = 1-Tex2.x;
	
	return 0.5 + 0.25 * (
		  (2.0 * tex2D( WeightSamp0, Tex).r - 1.0) * tex2D( SrcSamp0, Tex ) +
		  (2.0 * tex2D( WeightSamp1, Tex).r - 1.0) * tex2D( SrcSamp1, Tex2) );
}
// ------------------------------------------------------------
// SH(1,1)
// ------------------------------------------------------------
float4 PS_11 (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
) : COLOR0
{
	float4 Tex2 = Tex;
	Tex2.x = 1-Tex2.x;
	
	return 0.5 + 0.25 * (
		  (2.0 * tex2D( WeightSamp0, Tex).g - 1.0) * tex2D( SrcSamp0, Tex ) +
		  (2.0 * tex2D( WeightSamp1, Tex).g - 1.0) * tex2D( SrcSamp1, Tex2) );
}
// ------------------------------------------------------------
// SH(1,2)
// ------------------------------------------------------------
float4 PS_12 (
      float4 Pos    : POSITION           // f̒_
     ,float4 Tex    : TEXCOORD0	         // eNX`W
) : COLOR0
{
	float4 Tex2 = Tex;
	Tex2.x = 1-Tex2.x;
	
	return 0.5 + 0.25 * (
		  (2.0 * tex2D( WeightSamp0, Tex).b - 1.0) * tex2D( SrcSamp0, Tex ) +
		  (2.0 * tex2D( WeightSamp1, Tex).b - 1.0) * tex2D( SrcSamp1, Tex2) );
}


// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0 // GI & Envmap
    {
        VertexShader = compile vs_1_1 VS_ParabploidEnvmap();
        PixelShader  = compile ps_2_0 PS_ParabploidEnvmap();
    }
    pass P1// }bvȂ
    {
        VertexShader = compile vs_1_1 VS_ParabploidEnvmap();
        PixelShader  = compile ps_2_0 PS_ParabploidEnvmapNoEnv();
    }
    pass P2// GIȂ
    {
        VertexShader = compile vs_1_1 VS_ParabploidEnvmap();
        PixelShader  = compile ps_2_0 PS_ParabploidEnvmapNoGI();
    }
    
    pass P3 // k
    {
        VertexShader = compile vs_1_1 VS_Reduction();
        PixelShader  = compile ps_2_0 PS_Reduction();
    }
    pass P4
    {
        VertexShader = compile vs_1_1 VS_Parabploid();
        PixelShader  = compile ps_1_1 PS_Parabploid();
    }
    
    // n``
    pass P5
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
    
    pass P6
    {
        PixelShader = compile ps_2_0 PS_00();
    }
    pass P7
    {
        PixelShader = compile ps_2_0 PS_10();
    }
    pass P8
    {
        PixelShader = compile ps_2_0 PS_11();
    }
    pass P9
    {
        PixelShader = compile ps_2_0 PS_12();
    }
    
}
